<HTML>
<HEAD>

<TITLE>Common HEP UNIX User Environment - Software Quality Assurance (27-Jun-1996)</TITLE>
<!-- Changed by: Arnaud Taddei, 27-Jun-1996 -->

</HEAD>
<BODY>

<H1>Common HEP UNIX User Environment - Software Quality Assurance</H1>
 <P>
<HR>
In order to guaranty the production of the HEPiX Scripts package, we 
are following a certain process to improve the quality
<UL>
 <P><LI> <B>Optimisation</B> 
 <P> 
 The files are optimised using an equivalent of <B>cpp</B> but 
 for shell files. No more need to '<TT>case $OS</TT>' into a file

 <P><LI> <B>Compilation</B>
 <P>
 Any occurence of a UNIX command is replaced by its absolute path 
 for the specified system: allows robustness and security

 <P><LI> <B>Configurability</B>
 <P>
 Programs which can configure the scripts to fit to a file layout

 <P><LI> <B>Translation tools </B> 
 <P>
 Programs which can do a minimal translation from <B>csh2sh</B> 
 for example
</UL>
 <P>
<HR>
 <P>
<H2>Compilation</H2>
 <P>
With the new versions (above 2.4.1) the scripts are <I>compiled</I> which
means that each occurence of any UNIX command is replaced by the command
name plus the full absolute path.
 <P>
This is needed to prevent the following bug. Assume a user redefined
the '<B>whoami</B>' command and put it under <TT>$HOME/bin</TT>. If
in the file <TT>sys.conf.*</TT> you set <TT>USERPATH</TT> to be
'<TT>$HOME/bin /usr/bin ...</TT>' .
As <TT>$HOME/bin</TT> is before any other system directory in the 
<TT>USERPATH</TT> variable then in the <TT>PATH</TT> variable, the scripts 
will call the user
'<B>whoami</B>' command instead of the system one and they will probably 
break.
 <P>
Another feature of the compilation step is that the parsing algorithm
which was evaluating the environment variables you provided in the 
<TT>sys.conf.$OS</TT> file is replaced by a simple <I>source</I> of a file
<TT>sys.conf.csh</TT> or <TT>sys.conf.sh</TT> depending on the shell flavour
of the shell (csh = C-shell; sh = Bourne-shell).
 <P>
The latter files are the output of the compilation procedure and are the source
of these two files is the previous <TT>sys.conf.$OS</TT>.
It increases the performances and the flexibility.
 <P>
<HR>
<ADDRESS> <A Name=Signature HREF="http://xwho.cern.ch/WHO/people/26840">Arnaud Taddei</A>, 27-Jun-1996</ADDRESS>
</BODY>
</HTML>